function [tau_tk, xi_tlk, alpha_tk, beta_tk, loglik] = forwards_backwards(prior, transmat, f_tk) 
 

[T, K] = size(f_tk);

if nargin < 6, filter_only = 0; end

scale = ones(1,T);%pour que loglik = sum(log(scale)) part de zero

prior = prior(:); 
tau_tk = zeros(T,K);
xi_tlk = zeros(T-1,K,K);
alpha_tk = zeros(T,K);
beta_tk = zeros(T,K);

%% forwards: calculation of alpha_tk
t = 1;
alpha_tk(1,:) = prior' .* f_tk(t,:);
[alpha_tk(t,:), scale(t)] = normalise(alpha_tk(t,:));
for t=2:T
    [alpha_tk(t,:), scale(t)] = normalise((alpha_tk(t-1,:)*transmat) .* f_tk(t,:));
    %filtered_prob (t-1,:,:)= normalise((alpha(:,t-1) * fik(:,t)') .*transmat);
end
%%loglikehood (with the scaling technique) (see Rabiner's paper/book)
loglik = sum(log(scale));

if filter_only
  beta_tk = [];
  xi_tlk = alpha_tk;
  return;
end
%% backwards: calculation of beta_tk, tau_tk (and xi_tkl)
%t=T;
beta_tk(T,:) = ones(1,K);
tau_tk(T,:) = normalise(alpha_tk(T,:) .* beta_tk(T,:));
for t=T-1:-1:1
    beta_tk(t,:) =  normalise(  transmat * (beta_tk(t+1,:) .* f_tk(t+1,:))' );
    % transmat * (beta(t+1,:) .* fik(t+1,:))' /scale(t); 
    tau_tk(t,:) = normalise(alpha_tk(t,:) .* beta_tk(t,:));
    xi_tlk(t,:,:) = normalise((transmat .* (alpha_tk(t,:)' * (beta_tk(t+1,:) .* f_tk(t+1,:))))); 
end




