
function hmmr =  init_hmmr(X, y, K, type_variance, EM_try)
 
if strcmp(type_variance,'homoskedastic')
    homoskedastic = 1;
else
    homoskedastic = 0;
end
m = length(y);
 
Mask = .5*eye(K);%masque d'ordre 1
for k=1:K-1
    ind = find(Mask(k,:) ~= 0);
    Mask(k,ind+1) = .5;
end
hmmr.trans_mat = Mask;

% Initialisation de la loi initiale de la variable cachee
hmmr.prior = [1;zeros(K-1,1)];
hmmr.stats.Mask = Mask;
%  Initialisation des coeffecients de regression et des variances.
hmmr_reg = init_hmmr_regressors(X, y, K, homoskedastic, EM_try);

hmmr.reg_param = hmmr_reg;


function hmmr_reg_param = init_hmmr_regressors(X, y, K, homoskedastic, EM_try)


[m, P] = size(X);
 
if  EM_try ==1% uniform segmentation into K contiguous segments, and then a regression
    zi = round(m/K)-1;
    
    s=0;%if homoskedastic
    for k=1:K
        yk = y((k-1)*zi+1:k*zi);
        Xk = X((k-1)*zi+1:k*zi,:);
        
        hmmr_reg_param.betak(:,k) = inv(Xk'*Xk + 1e-4*eye(P))*Xk'*yk;%regress(yk,Xk); % for a use in octave, where regress doesnt exist
        muk = Xk*hmmr_reg_param.betak(:,k);
        sk = (yk-muk)'*(yk-muk);
        if homoskedastic
           s= (s+sk);
           hmmr_reg_param.sigma2 = s/m;
        else
            hmmr_reg_param.sigma2k(k) = sk/length(yk);
        end
    end
    
else % random segmentation into contiguous segments, and then a regression
    Lmin= P+1;%minimum length of a segment %10
    tk_init = zeros(K,1);
    tk_init(1) = 0;
    K_1=K;
    for k = 2:K
        K_1 = K_1-1;
        temp = tk_init(k-1)+Lmin:m-K_1*Lmin;
        ind = randperm(length(temp));
        tk_init(k)= temp(ind(1));
    end
    tk_init(K+1) = m;
    
    s=0;%
    for k=1:K
        i = tk_init(k)+1;
        j = tk_init(k+1);
        yk = y(i:j);%y((k-1)*zi+1:k*zi);
        Xk = X(i:j,:);%X((k-1)*zi+1:k*zi,:);
        hmmr_reg_param.betak(:,k) = inv(Xk'*Xk + 1e-4*eye(P))*Xk'*yk;%regress(yk,Xk); % for a use in octave, where regress doesnt exist
        muk = Xk* hmmr_reg_param.betak(:,k);
        sk = (yk-muk)'*(yk-muk);
        
        if homoskedastic
            s = s+sk;
             hmmr_reg_param.sigma2 = s/m;
        else
            hmmr_reg_param.sigma2k(k) = sk/length(yk);%
        end
    end
end
%

