function T = mk_stochastic(T)
 

if (ndims(T)==2) & (size(T,1)==1 | size(T,2)==1) % isvector
  T = normalise(T);
elseif ndims(T)==2 % matrix
  S = sum(T,2); 
  S = S + (S==0);
  norm = repmat(S, 1, size(T,2));
  T = T ./ norm;
else % multi-dimensional array
  ns = size(T);
  T = reshape(T, prod(ns(1:end-1)), ns(end));
  S = sum(T,2);
  S = S + (S==0);
  norm = repmat(S, 1, ns(end));
  T = T ./ norm;
  T = reshape(T, ns);
end
